打开APP
userphoto
未登录

开通VIP,畅享免费电子书等14项超值服

开通VIP
LeetCode之Next Greater Element I

1、题目

You are given two arrays (without duplicates) nums1 and nums2 where nums1’s elements are subset of nums2. Find all the next greater numbers for nums1's elements in the corresponding places of nums2.

The Next Greater Number of a number x in nums1 is the first greater number to its right in nums2. If it does not exist, output -1 for this number.

Example 1:
Input: nums1 = [4,1,2], nums2 = [1,3,4,2].
Output: [-1,3,-1]
Explanation:
    For number 4 in the first array, you cannot find the next greater number for it in the second array, so output -1.
    For number 1 in the first array, the next greater number for it in the second array is 3.
    For number 2 in the first array, there is no next greater number for it in the second array, so output -1.
Example 2:
Input: nums1 = [2,4], nums2 = [1,2,3,4].
Output: [3,-1]
Explanation:
    For number 2 in the first array, the next greater number for it in the second array is 3.
    For number 4 in the first array, there is no next greater number for it in the second array, so output -1.

给你两个数组,为数组1和数组2,数组1为数组2的子集。找出数组1的每一个元素在数组2中对应的元素a,然后找到元素a后侧第一个比a大的数构成一个数组,即是我们需要的答案。如果不存在,则为-1。

Input: nums1 = [4,1,2], nums2 = [1,3,4,2].
Output: [-1,3,-1]

 
 


2、代码实现

public class Solution {
    public int[] nextGreaterElement(int[] findNums, int[] nums) {
        if (findNums == null || nums == null) {
            return null;
        }
        int findLength = findNums.length;
        int numsLength = nums.length;
        int[] result = new int[findLength];
        boolean flag = false;
        for (int i = 0; i < findLength;  ++i) {
            for (int j = 0; j < numsLength; ++j) {
                if (findNums[i] == nums[j]) {
                    if (j + 1 == numsLength) {
                        result[i] = -1;
                    } else {
                        for (int k = j + 1;  k < numsLength; ++k) {
                            if (nums[j] < nums[k]) { 
                                result[i] = nums[k];
                                flag = true;
                                break;
                            }
                        }
                        if (!flag) {
                            result[i] = -1;
                        }
                    }
                    flag = false;
                }
            }
        }
        return result;    
    }
}

 
 


3、总结我遇到的问题

我一开始写这里的代码的时候
                        for (int k = j + 1;  k < numsLength; ++k) {
                            if (nums[j] < nums[k]) { 
                                result[i] = nums[k];
                                flag = true;
                                break;
                            }
                        }
忘记了写break;
然后导致第一个元素符合条件了,但是后面也有符合条件的,导致result[i],取到的元素是最后面符合条件的元素,就错了,所以,这个时候条件是说,得到第一个大于前面的数
就可以了,我们需要用break跳出循环,防穿透,防止继续便利后面的元素,所以以后编程,看到符合后面第一个元素满足要求的时候,要记得用break;形成条件反射。
本站仅提供存储服务,所有内容均由用户发布,如发现有害或侵权内容,请点击举报
打开APP,阅读全文并永久保存 查看更多类似文章
猜你喜欢
类似文章
88 [Leetcode] Merge Sorted Array 合并数组
[LeetCode] 496. Next Greater Element I 下一个较大的元素 I
单调栈 Monotonic Stack 的使用
斯坦福CS231n深度学习课程笔记翻译(一)
Python中基础使用及Numpy、Scipy、Matplotlib 使用教程
leetcode - 分割数组的最大值
更多类似文章 >>
生活服务
热点新闻
分享 收藏 导长图 关注 下载文章
绑定账号成功
后续可登录账号畅享VIP特权!
如果VIP功能使用有故障,
可点击这里联系客服!

联系客服